## cbmc 3.9+r41

=== src/Makefile ===
DIRS = ansi-c big-int cbmc cpp goto-cc goto-instrument goto-programs \
       goto-symex langapi pointer-analysis solvers util xmllang

all: cbmc.dir goto-cc.dir goto-instrument.dir

include config.inc
include common

###############################################################################

util.dir: big-int.dir

languages: util.dir langapi.dir \
           cpp.dir ansi-c.dir xmllang.dir

goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir

cbmc.dir: languages solvers.dir goto-symex.dir \
          pointer-analysis.dir goto-programs.dir goto-symex.dir

goto-cc.dir: languages pointer-analysis.dir goto-programs.dir

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

clean: $(patsubst %, %_clean, $(DIRS))
	rm -f *.o

dep: $(patsubst %, %_dep, $(DIRS))

$(patsubst %, %_clean, $(DIRS)):
	if [ -e $(patsubst %_clean, %, $@)/. ] ; then \
		$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \
	fi

$(patsubst %, %_dep, $(DIRS)):
	if [ -e $(patsubst %_dep, %, $@)/. ] ; then \
		$(MAKE) $(MAKEARGS) -C $(patsubst %_dep, %, $@) dep ; \
	fi

=== src/ansi-c/Makefile ===
SRC = c_typecast.cpp y.tab.cpp lex.yy.cpp ansi_c_parser.cpp \
      expr2c.cpp ansi_c_language.cpp c_sizeof.cpp c_main.cpp \
      c_types.cpp c_final.cpp trans_unit.cpp ansi_c_typecheck.cpp \
      c_link.cpp c_preprocess.cpp c_link_type_eq.cpp \
      c_typecheck_base.cpp c_typecheck_initializer.cpp \
      c_typecheck_typecast.cpp c_typecheck_code.cpp \
      c_typecheck_expr.cpp c_typecheck_type.cpp string_constant.cpp \
      c_qualifiers.cpp c_typecheck_argc_argv.cpp ansi_c_parse_tree.cpp \
      preprocessor_line.cpp ansi_c_convert.cpp ansi_c_convert_type.cpp \
      type2name.cpp cprover_library.cpp \
      printf_formatter.cpp internal_additions.cpp \
      ansi_c_declaration.cpp designator.cpp concatenate_strings.cpp \
      literals/parse_float.cpp literals/unescape_string.cpp \
      literals/convert_float_literal.cpp \
      literals/convert_character_literal.cpp \
      literals/convert_integer_literal.cpp \
      literals/convert_string_literal.cpp 

OBJ = $(SRC:.cpp=$(OBJEXT))

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

all: ansi-c$(LIBEXT) library/converter$(EXEEXT)

###############################################################################

y.tab.cpp: parser.y
	$(YACC) $(YFLAGS) $$flags -pyyansi_c -d parser.y -o y.tab.cpp

y.tab.h: y.tab.cpp
	if [ -e y.tab.hpp ] ; then mv y.tab.hpp y.tab.h ; else \
        mv y.tab.cpp.h y.tab.h ; fi

lex.yy.cpp: scanner.l
	$(LEX) -Pyyansi_c -olex.yy.cpp scanner.l

# extra dependencies
y.tab$(OBJEXT): y.tab.cpp y.tab.h
lex.yy$(OBJEXT): y.tab.cpp lex.yy.cpp y.tab.h
cprover_library$(OBJEXT): cprover_library.inc

###############################################################################

library/converter$(EXEEXT):
	$(CXX) $(LINKFLAGS) -o $@ library/converter.cpp
	
cprover_library.inc: library/converter library/*.c
	cat library/*.c | library/converter > $@

cprover_library.cpp: cprover_library.inc

###############################################################################

ansi-c$(LIBEXT): $(OBJ) 
	$(LINKLIB)

clean:
	rm -f $(OBJ) ansi-c$(LIBEXT)
	rm -f y.tab.h y.tab.cpp lex.yy.cpp y.tab.cpp.output y.output
	rm -f library/converter$(EXEEXT) cprover_library.inc

=== src/cbmc/Makefile ===
SRC = main.cpp parseoptions.cpp bmc.cpp dimacs.cpp languages.cpp \
      bv_cbmc.cpp symex_bmc.cpp show_vcc.cpp cbmc_solvers.cpp \
      xml_interface.cpp \
      counterexample_beautification.cpp \
      counterexample_beautification_greedy.cpp \
      counterexample_beautification_pbs.cpp

OBJ = $(SRC:.cpp=$(OBJEXT)) \
      ../ansi-c/ansi-c$(LIBEXT) \
      ../big-int/bigint$(OBJEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../solvers/solvers$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I .. -I ../util

LIBS =

include ../config.inc
include ../common

all: cbmc$(EXEEXT)

ifdef MODULE_BV_REFINEMENT
  OBJ += ../bv_refinement/bv_refinement$(LIBEXT)
  CXXFLAGS += -DHAVE_BV_REFINEMENT
endif

ifdef MODULE_CPP
  OBJ += ../cpp/cpp$(LIBEXT)
  CXXFLAGS += -DHAVE_CPP
endif

ifdef MODULE_JAVA
  OBJ += ../java/java$(LIBEXT)
  CXXFLAGS += -DHAVE_JAVA
endif

ifdef MODULE_SPECC
  OBJ += ../specc/specc$(LIBEXT)
  CXXFLAGS += -DHAVE_SPECC
endif

ifdef MODULE_PHP
  OBJ += ../php/php$(LIBEXT)
  CXXFLAGS += -DHAVE_PHP
endif

ifneq ($(Z3),)
  CXXFLAGS += -DHAVE_Z3
endif

ifneq ($(BOOLECTOR),)
  CXXFLAGS += -DHAVE_BOOLECTOR
endif

###############################################################################

cbmc$(EXEEXT): $(OBJ)
	$(CXX) $(LINKFLAGS) -o $@ $(OBJ) $(LIBS)

clean:
	rm -f $(SRC:.cpp=$(OBJEXT)) cbmc$(EXEEXT)

=== src/goto-cc/Makefile ===
SRC = goto-cc.cpp \
      cmdline_options.cpp get_base_name.cpp \
      gcc_cmdline.cpp ms_cl_cmdline.cpp \
      compile.cpp armcc_cmdline.cpp \
      languages.cpp goto_cc_cmdline.cpp \
      xml_binaries/xml_irep_hashing.cpp \
      xml_binaries/xml_symbol_hashing.cpp \
      xml_binaries/xml_symbol.cpp \
      xml_binaries/xml_goto_function.cpp \
      xml_binaries/xml_goto_function_hashing.cpp \
      xml_binaries/xml_goto_program.cpp \
      xml_binaries/xml_goto_program_hashing.cpp \
      xml_binaries/read_goto_object.cpp

OBJ = $(SRC:.cpp=$(OBJEXT)) \
      ../big-int/bigint$(OBJEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../util/util$(LIBEXT) \
      ../ansi-c/ansi-c$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../langapi/langapi$(LIBEXT)

INCLUDES= -I .. -I ../util

LIBS =

include ../config.inc
include ../common

all: goto-cc$(EXEEXT)

ifdef MODULE_CPP
  OBJ += ../cpp/cpp$(LIBEXT)
  CXXFLAGS += -D HAVE_CPP
endif

###############################################################################

goto-cc$(EXEEXT): $(OBJ)
	$(CXX) $(LINKFLAGS) -o $@ $(OBJ) $(LIBS) 

clean:
	rm -f $(SRC:.cpp=$(OBJEXT)) $(SRC:.cpp=.d) goto-cc$(EXEEXT)

=== src/goto-instrument/Makefile ===
SRC = main.cpp parseoptions.cpp document_claims.cpp languages.cpp \
      uninitialized.cpp uninitialized_domain.cpp full_slicer.cpp \
      object_id.cpp show_locations.cpp points_to.cpp
OBJ = $(SRC:.cpp=$(OBJEXT)) \
      ../ansi-c/ansi-c$(LIBEXT) \
      ../big-int/bigint$(OBJEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I .. -I ../util

LIBS =

include ../config.inc
include ../common

all: goto-instrument$(EXEEXT)

ifdef MODULE_CPP
  OBJ += ../cpp/cpp$(LIBEXT)
  CXXFLAGS += -DHAVE_CPP
endif

ifdef MODULE_JAVA
  OBJ += ../java/java$(LIBEXT)
  CXXFLAGS += -DHAVE_JAVA
endif

ifdef MODULE_SPECC
  OBJ += ../specc/specc$(LIBEXT)
  CXXFLAGS += -DHAVE_SPECC
endif

ifdef MODULE_PHP
  OBJ += ../php/php$(LIBEXT)
  CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

goto-instrument$(EXEEXT): $(OBJ)
	$(CXX) $(LINKFLAGS) -o $@ $(OBJ) $(LIBS)

clean:
	rm -f $(SRC:.cpp=$(OBJEXT)) goto-instrument$(EXEEXT)

=== src/goto-programs/Makefile ===
SRC = goto_convert.cpp goto_function.cpp goto_main.cpp goto_sideeffects.cpp \
      goto_program.cpp basic_blocks.cpp goto_threads.cpp goto_check.cpp \
      goto_function_pointers.cpp goto_functions.cpp goto_inline.cpp \
      remove_skip.cpp goto_convert_functions.cpp string_instrumentation.cpp \
      builtin_functions.cpp show_claims.cpp destructor.cpp set_claims.cpp \
      slicer.cpp invariant_set.cpp invariant_propagation.cpp \
      add_race_assertions.cpp rw_set.cpp read_goto_binary.cpp \
      invariant_set_domain.cpp static_analysis.cpp string_abstraction.cpp \
      goto_program_serialization.cpp goto_function_serialization.cpp \
      read_bin_goto_object.cpp goto_program_irep.cpp interpreter.cpp \
      interpreter_evaluate.cpp flow_insensitive_analysis.cpp \
      format_strings.cpp loop_numbers.cpp pointer_arithmetic.cpp \
      goto_program_template.cpp write_goto_binary.cpp remove_unreachable.cpp \
      remove_unused_functions.cpp dynamic_memory.cpp dump_c.cpp \
      wp.cpp goto_rw.cpp goto_clean_expr.cpp safety_checker.cpp \
      control_flow_graph.cpp depth_first_spanning_tree.cpp dominator_info.cpp \
      loops.cpp

OBJ = $(SRC:.cpp=$(OBJEXT))

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

all: goto-programs$(LIBEXT)

###############################################################################

goto-programs$(LIBEXT): $(OBJ)
	$(LINKLIB)

test_wp$(EXEEXT): test_wp$(OBJEXT) goto-programs$(LIBEXT)
	$(CXX) $(LINKFLAGS) test_wp$(OBJEXT) -o test_wp$(EXEEXT) \
	../ansi-c/ansi-c$(LIBEXT)  ../util/util$(LIBEXT) \
	../big-int/bigint$(OBJEXT) goto-programs$(LIBEXT) \
	../pointer-analysis/pointer-analysis$(LIBEXT) \
	../langapi/langapi$(LIBEXT)

clean:
	rm -f $(OBJ) goto-programs$(LIBEXT) test_wp$(EXEEXT)

=== src/goto-symex/Makefile ===
SRC = symex_target.cpp symex_target_equation.cpp basic_symex.cpp \
      symex_main.cpp goto_trace.cpp build_goto_trace.cpp \
      symex_function.cpp goto_symex_state.cpp symex_dereference.cpp \
      symex_goto.cpp builtin_functions.cpp slice.cpp symex_other.cpp \
      slice_by_trace.cpp xml_goto_trace.cpp symex_decl.cpp \
      precondition.cpp postcondition.cpp symex_clean_expr.cpp \
      symex_dereference_state.cpp

OBJ = $(SRC:.cpp=$(OBJEXT))

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

all: goto-symex$(LIBEXT)

###############################################################################

goto-symex$(LIBEXT): $(OBJ)
	$(LINKLIB)

clean:
	rm -f $(OBJ) goto-symex$(LIBEXT)

=== src/util/Makefile ===
SRC = arith_tools.cpp base_type.cpp cmdline.cpp config.cpp context.cpp \
      expr.cpp expr_util.cpp i2string.cpp irep.cpp language.cpp \
      lispexpr.cpp lispirep.cpp location.cpp message.cpp language_file.cpp \
      mp_arith.cpp namespace.cpp parseoptions.cpp rename.cpp \
      replace_expr.cpp threeval.cpp typecheck.cpp graph.cpp \
      type.cpp cnf_simplify.cpp str_getline.cpp strstream2string.cpp \
      bitvector.cpp parser.cpp map_util.cpp replace_symbol.cpp actuals.cpp \
      get_module.cpp string_hash.cpp string_container.cpp identifier.cpp \
      rational.cpp options.cpp c_misc.cpp simplify_expr.cpp dstring.cpp \
      find_symbols.cpp rational_tools.cpp ui_message.cpp simplify_utils.cpp \
      time_stopping.cpp symbol.cpp \
      type_eq.cpp guard.cpp array_name.cpp gcd.cpp message_stream.cpp \
      substitute.cpp decision_procedure.cpp union_find.cpp pretty_names.cpp \
      xml.cpp xml_irep.cpp std_types.cpp std_code.cpp \
      format_constant.cpp find_macros.cpp ref_expr_set.cpp std_expr.cpp \
      irep_serialization.cpp symbol_serialization.cpp fixedbv.cpp \
      ieee_float.cpp signal_catcher.cpp pointer_offset_size.cpp \
      bv_arithmetic.cpp tempdir.cpp tempfile.cpp timer.cpp \
      irep_ids.cpp

OBJ = $(SRC:.cpp=$(OBJEXT))

INCLUDES= -I .. -I .

include ../config.inc
include ../common

all: util$(LIBEXT) ieee_float_test$(EXEEXT)

ifdef MODULE_FLOATBV
  CXXFLAGS += -DHAVE_FLOATBV
endif

###############################################################################

irep_ids.h: irep_ids_convert$(EXEEXT) irep_ids.txt
	./irep_ids_convert header < irep_ids.txt > $@

irep_ids.inc: irep_ids_convert$(EXEEXT) irep_ids.txt
	./irep_ids_convert table < irep_ids.txt > $@

irep_ids.cpp: irep_ids.inc irep_ids.h

irep_ids_convert$(EXEEXT): irep_ids_convert$(OBJEXT)
	$(CXX) $(LINKFLAGS) -o $@ irep_ids_convert$(OBJEXT)

$(OBJ): irep_ids.h

util$(LIBEXT): $(OBJ)
	$(LINKLIB)

clean:
	rm -f $(OBJ) util$(LIBEXT)
	rm -f irep_ids.h irep_ids.inc
	rm -f ieee_float_test$(EXEEXT) ieee_float_test$(OBJEXT)
	rm -f irep_ids_convert$(EXEEXT) irep_ids_convert$(OBJEXT)          

ieee_float_test$(OBJEXT): irep_ids.h  

ieee_float_test$(EXEEXT): ieee_float_test$(OBJEXT) ieee_float$(OBJEXT) util$(LIBEXT)
	$(CXX) $(LINKFLAGS) -o $@ util$(LIBEXT) ieee_float_test$(OBJEXT) ../big-int/bigint$(OBJEXT)

=== debian/changelog ===
cbmc (3.9+r41-3) unstable; urgency=low

  * Fix another FTBFS for ambiguous overload, missing freebsd kernel define

 -- Michael Tautschnig <mt@debian.org>  Sat, 14 May 2011 16:11:44 +0200

cbmc (3.9+r41-2) unstable; urgency=low

  * Corrected build-depends to fix FTBFS
  * Added gcc as depends

 -- Michael Tautschnig <mt@debian.org>  Sat, 14 May 2011 14:57:05 +0200

cbmc (3.9+r41-1) unstable; urgency=low

  * Initial upload (closes: #626635)
  * Version 3.9 + all changes of SVN r41

 -- Michael Tautschnig <mt@debian.org>  Fri, 13 May 2011 23:54:50 +0200

=== debian/control ===
Source: cbmc
Section: science
Priority: extra
Maintainer: Michael Tautschnig <mt@debian.org>
Build-Depends: debhelper (>= 7.0.50~), minisat, zlib1g-dev, flex, bison
Standards-Version: 3.9.2
Homepage: http://www.cprover.org/cbmc/

Package: cbmc
Architecture: any
Depends: gcc, ${shlibs:Depends}, ${misc:Depends}
Description: bounded model checker for C and C++ programs
 CBMC generates traces that demonstrate how an assertion can be violated, or
 proves that the assertion cannot be violated within a given number of loop
 iterations.

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# Uncomment to examine a Webpage
# <Webpage URL> <string match>
http://www.cprover.org/cbmc/ cbmc-(.*).tar.gz

## cbmc 4.0

=== src/Makefile ===
--- 
+++ 
@@ -9,6 +9,9 @@
 ###############################################################################
 
 util.dir: big-int.dir
+
+# everything depends on util
+$(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir
 
 languages: util.dir langapi.dir \
            cpp.dir ansi-c.dir xmllang.dir
@@ -25,7 +28,7 @@
 	$(MAKE) $(MAKEARGS) -C $(basename $@)
 
 clean: $(patsubst %, %_clean, $(DIRS))
-	rm -f *.o
+	rm -f *.o $(shell find . -name "*.d")
 
 dep: $(patsubst %, %_dep, $(DIRS))

=== src/ansi-c/Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
       c_typecheck_expr.cpp c_typecheck_type.cpp string_constant.cpp \
       c_qualifiers.cpp c_typecheck_argc_argv.cpp ansi_c_parse_tree.cpp \
       preprocessor_line.cpp ansi_c_convert.cpp ansi_c_convert_type.cpp \
-      type2name.cpp cprover_library.cpp \
+      type2name.cpp cprover_library.cpp anonymous_member.cpp \
       printf_formatter.cpp internal_additions.cpp \
       ansi_c_declaration.cpp designator.cpp concatenate_strings.cpp \
       literals/parse_float.cpp literals/unescape_string.cpp \
@@ -35,7 +35,7 @@
         mv y.tab.cpp.h y.tab.h ; fi
 
 lex.yy.cpp: scanner.l
-	$(LEX) -Pyyansi_c -olex.yy.cpp scanner.l
+	$(LEX) -Pyyansi_c -o$@ scanner.l
 
 # extra dependencies
 y.tab$(OBJEXT): y.tab.cpp y.tab.h

=== src/cbmc/Makefile ===
--- 
+++ 
@@ -61,7 +61,7 @@
 ###############################################################################
 
 cbmc$(EXEEXT): $(OBJ)
-	$(CXX) $(LINKFLAGS) -o $@ $(OBJ) $(LIBS)
+	$(LINKBIN) $(OBJ)
 
 clean:
 	rm -f $(SRC:.cpp=$(OBJEXT)) cbmc$(EXEEXT)

=== src/cpp/Makefile ===
SRC = cpp_id.cpp cpp_language.cpp expr2cpp.cpp cpp_parser.cpp \
      lex.yy.cpp cpp_typecheck.cpp cpp_convert_type.cpp \
      cpp_typecheck_expr.cpp cpp_typecheck_code.cpp \
      cpp_typecheck_type.cpp parse.cpp cpp_parse_tree.cpp \
      cpp_token_buffer.cpp cpp_typecheck_fargs.cpp \
      cpp_typecheck_resolve.cpp cpp_util.cpp \
      cpp_typecheck_function.cpp cpp_typecheck_namespace.cpp \
      cpp_name.cpp cpp_is_pod.cpp cpp_scope.cpp \
      cpp_typecheck_find_constructor.cpp template_map.cpp \
      cpp_scopes.cpp cpp_declarator.cpp cpp_instantiate_template.cpp \
      internal_additions.cpp cpp_type2name.cpp \
      cpp_typecheck_linkage_spec.cpp \
      cpp_typecheck_template.cpp cpp_typecheck_function_bodies.cpp \
      cpp_typecheck_initializer.cpp cpp_typecheck_compound_type.cpp \
      cpp_constructor.cpp cpp_destructor.cpp \
      cpp_final.cpp cpp_typecheck_conversions.cpp\
      cpp_typecheck_declaration.cpp cpp_declarator_converter.cpp \
      cpp_declaration.cpp cpp_namespace_spec.cpp \
      cpp_typecheck_using.cpp \
      cpp_typecheck_enum_type.cpp cpp_typecheck_bases.cpp \
      cpp_typecheck_constructor.cpp cpp_typecheck_virtual_table.cpp

OBJ = $(SRC:.cpp=$(OBJEXT))

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

all: cpp$(LIBEXT)

GCCFLAGS += -D CPP_SYSTEMC_EXTENSION

###############################################################################

cpp$(LIBEXT): $(OBJ)
	$(LINKLIB)

lex.yy.cpp: scanner.l
	$(LEX) -Pyycpp -olex.yy.cpp scanner.l

lex.yy$(OBJEXT): lex.yy.cpp

clean:
	rm -f $(OBJ) cpp$(LIBEXT) lex.yy.cpp y.tab.cpp.output

dep: lex.yy.cpp

=== src/goto-cc/Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 ###############################################################################
 
 goto-cc$(EXEEXT): $(OBJ)
-	$(CXX) $(LINKFLAGS) -o $@ $(OBJ) $(LIBS) 
+	$(LINKBIN) $(OBJ)
 
 clean:
 	rm -f $(SRC:.cpp=$(OBJEXT)) $(SRC:.cpp=.d) goto-cc$(EXEEXT)

=== src/goto-instrument/Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 SRC = main.cpp parseoptions.cpp document_claims.cpp languages.cpp \
       uninitialized.cpp uninitialized_domain.cpp full_slicer.cpp \
-      object_id.cpp show_locations.cpp points_to.cpp
+      object_id.cpp show_locations.cpp points_to.cpp \
+      alignment_checks.cpp
 OBJ = $(SRC:.cpp=$(OBJEXT)) \
       ../ansi-c/ansi-c$(LIBEXT) \
       ../big-int/bigint$(OBJEXT) \
@@ -42,7 +43,7 @@
 ###############################################################################
 
 goto-instrument$(EXEEXT): $(OBJ)
-	$(CXX) $(LINKFLAGS) -o $@ $(OBJ) $(LIBS)
+	$(LINKBIN) $(OBJ)
 
 clean:
 	rm -f $(SRC:.cpp=$(OBJEXT)) goto-instrument$(EXEEXT)

=== src/goto-programs/Makefile ===
--- 
+++ 
@@ -13,8 +13,7 @@
       goto_program_template.cpp write_goto_binary.cpp remove_unreachable.cpp \
       remove_unused_functions.cpp dynamic_memory.cpp dump_c.cpp \
       wp.cpp goto_rw.cpp goto_clean_expr.cpp safety_checker.cpp \
-      control_flow_graph.cpp depth_first_spanning_tree.cpp dominator_info.cpp \
-      loops.cpp
+      compute_called_functions.cpp link_to_library.cpp
 
 OBJ = $(SRC:.cpp=$(OBJEXT))

=== src/goto-symex/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
       symex_goto.cpp builtin_functions.cpp slice.cpp symex_other.cpp \
       slice_by_trace.cpp xml_goto_trace.cpp symex_decl.cpp \
       precondition.cpp postcondition.cpp symex_clean_expr.cpp \
-      symex_dereference_state.cpp
+      symex_dereference_state.cpp vcd_goto_trace.cpp auto_objects.cpp
 
 OBJ = $(SRC:.cpp=$(OBJEXT))

=== src/langapi/Makefile ===
SRC = mode.cpp language_ui.cpp languages.cpp language_util.cpp

OBJ = $(SRC:.cpp=$(OBJEXT))

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

all: langapi$(LIBEXT)

###############################################################################

langapi$(LIBEXT): $(OBJ)
	$(LINKLIB)
	
clean:
	rm -f $(OBJ) langapi$(LIBEXT)

=== src/pointer-analysis/Makefile ===
SRC = value_set.cpp goto_program_dereference.cpp value_set_analysis.cpp \
      dereference.cpp pointer_offset_sum.cpp add_failed_symbols.cpp \
      show_value_sets.cpp value_set_domain.cpp rewrite_index.cpp \
      value_set_analysis_fi.cpp value_set_fi.cpp value_set_domain_fi.cpp \
      value_set_analysis_fivr.cpp value_set_fivr.cpp value_set_domain_fivr.cpp \
      value_set_analysis_fivrns.cpp value_set_fivrns.cpp \
      value_set_domain_fivrns.cpp

OBJ = $(SRC:.cpp=$(OBJEXT))

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

all: pointer-analysis$(LIBEXT)

###############################################################################

pointer-analysis$(LIBEXT): $(OBJ)
	$(LINKLIB)

clean:
	rm -f $(OBJ) pointer-analysis$(LIBEXT)

=== src/solvers/Makefile ===
include ../config.inc

all: solvers$(LIBEXT)

ifneq ($(CHAFF),)
  CHAFF_SRC=sat/satcheck_zchaff.cpp sat/satcheck_zcore.cpp
  CHAFF_INCLUDE=-I $(CHAFF)
  CHAFF_LIB=$(CHAFF)/libsat.a
endif

ifneq ($(BOOLEFORCE),)
  BOOLEFORCE_SRC=sat/satcheck_booleforce.cpp
  BOOLEFORCE_INCLUDE=-I $(BOOLEFORCE)
  BOOLEFORCE_LIB=$(BOOLEFORCE)/libbooleforce.a
endif

ifneq ($(Z3),)
  Z3_SRC=z3/z3_capi.cpp z3/z3_conv.cpp z3/z3_prop.cpp z3/z3_dec.cpp
  Z3_INCLUDE=-I $(Z3)
  Z3_LIB=
  CXXFLAGS += -DHAVE_Z3
endif

ifneq ($(BOOLECTOR),)
  BOOLECTOR_SRC=boolector/boolector_get.cpp \
                boolector/boolector_prop.cpp boolector/boolector_dec.cpp
  BOOLECTOR_INCLUDE=-I $(BOOLECTOR)
  BOOLECTOR_LIB=$(BOOLECTOR)/lib/libboolector.a
  CXXFLAGS += -DHAVE_BOOLECTOR
endif

ifneq ($(MINISAT),)
  MINISAT_SRC=sat/satcheck_minisat.cpp 
  MINISAT_INCLUDE=-I $(MINISAT)
  MINISAT_LIB=$(MINISAT)/Solver$(OBJEXT) $(MINISAT)/Proof$(OBJEXT) $(MINISAT)/File$(OBJEXT)
  CXXFLAGS += -DHAVE_MINISAT
endif

ifneq ($(MINISAT2),)
  MINISAT2_SRC=sat/satcheck_minisat2.cpp
  MINISAT2_INCLUDE=-I $(MINISAT2)
  MINISAT2_LIB=$(MINISAT2)/simp/SimpSolver$(OBJEXT) $(MINISAT2)/core/Solver$(OBJEXT)
  CXXFLAGS += -DHAVE_MINISAT2 -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS
  GCCFLAGS := $(filter-out -pedantic, $(GCCFLAGS))
endif

ifneq ($(SMVSAT),)
  SMVSAT_SRC=sat/satcheck_smvsat.cpp
  SMVSAT_INCLUDE=-I $(SMVSAT)/include
  SMVSAT_LIB=$(SMVSAT)/lib/libsmvsat.a
endif

ifneq ($(SQUOLEM2),)
  SQUOLEM2_SRC=qbf/qbf_squolem.cpp qbf/qbf_squolem_core.cpp
  SQUOLEM2_INCLUDE=-I $(SQUOLEM2)
  SQUOLEM2_LIB=-L $(SQUOLEM2) -lsquolem2
endif

ifneq ($(CUDD),)
  CUDD_SRC=qbf/qbf_bdd_core.cpp qbf/qbf_skizzo_core.cpp
  CUDD_INCLUDE=-I $(CUDD)/include
  CUDD_LIB=-L $(CUDD)/cudd -L $(CUDD)/util -L $(CUDD)/mtr \
           -L $(CUDD)/st -L $(CUDD)/obj -L $(CUDD)/dddmp \
           -L $(CUDD)/epd -lobj -lcudd -lmtr -lst -lutil -lepd -ldddmp
endif

SRC = $(CHAFF_SRC) $(BOOLEFORCE_SRC) $(MINISAT_SRC) $(MINISAT2_SRC) \
      $(SMVSAT_SRC) $(SQUOLEM2_SRC) $(CUDD_SRC) $(BOOLECTOR_SRC) \
      $(Z3_SRC) \
      sat/cnf.cpp sat/dimacs_cnf.cpp sat/cnf_clause_list.cpp \
      sat/pbs_dimacs_cnf.cpp sat/read_dimacs_cnf.cpp \
      sat/resolution_proof.cpp sat/satcheck.cpp \
      qbf/qdimacs_cnf.cpp qbf/qbf_quantor.cpp \
      qbf/qbf_skizzo.cpp qbf/qdimacs_core.cpp qbf/qbf_qube.cpp \
      qbf/qbf_qube_core.cpp \
      prop/prop.cpp prop/prop_conv.cpp prop/prop_conv_store.cpp \
      prop/aig_formula.cpp \
      prop/aig.cpp prop/aig_prop.cpp \
      cvc/cvc_prop.cpp cvc/cvc_conv.cpp cvc/cvc_dec.cpp \
      smt1/smt1_dec.cpp smt1/smt1_prop.cpp smt1/smt1_conv.cpp \
      smt2/smt2_dec.cpp smt2/smt2_prop.cpp smt2/smt2_conv.cpp \
      dplib/dplib_conv.cpp dplib/dplib_dec.cpp dplib/dplib_prop.cpp \
      flattening/equality.cpp flattening/arrays.cpp \
      flattening/functions.cpp flattening/sat_minimizer.cpp \
      flattening/boolbv_width.cpp flattening/boolbv.cpp \
      flattening/boolbv_constraint_select_one.cpp \
      flattening/bv_pointers.cpp flattening/bv_utils.cpp \
      flattening/boolbv_abs.cpp flattening/boolbv_with.cpp \
      flattening/boolbv_typecast.cpp flattening/boolbv_index.cpp \
      flattening/boolbv_member.cpp flattening/boolbv_if.cpp \
      flattening/boolbv_byte_extract.cpp flattening/boolbv_add_sub.cpp \
      flattening/boolbv_mult.cpp flattening/boolbv_constant.cpp \
      flattening/boolbv_extractbit.cpp flattening/boolbv_bv_rel.cpp \
      flattening/boolbv_shift.cpp flattening/boolbv_case.cpp \
      flattening/boolbv_cond.cpp flattening/boolbv_concatenation.cpp \
      flattening/boolbv_div.cpp flattening/boolbv_mod.cpp \
      flattening/boolbv_extractbits.cpp flattening/boolbv_replication.cpp \
      flattening/boolbv_reduction.cpp flattening/boolbv_overflow.cpp \
      flattening/boolbv_get.cpp flattening/boolbv_bitwise.cpp \
      flattening/boolbv_equality.cpp flattening/boolbv_unary_minus.cpp \
      flattening/boolbv_ieee_float_rel.cpp flattening/pointer_logic.cpp \
      flattening/boolbv_quantifier.cpp flattening/boolbv_struct.cpp \
      flattening/boolbv_byte_update.cpp flattening/boolbv_array_of.cpp \
      flattening/boolbv_map.cpp flattening/boolbv_type.cpp \
      flattening/boolbv_union.cpp

OBJ = $(SRC:.cpp=$(OBJEXT))

ifneq ($(SQUOLEM2),)
  CXXFLAGS += -DHAVE_QBF_CORE
else
ifneq ($(CUDD),)
  CXXFLAGS += -DHAVE_QBF_CORE
endif
endif

ifdef MODULE_FLOATBV
  CXXFLAGS += -DHAVE_FLOATBV
  OBJ += ../floatbv/floatbv$(LIBEXT)
endif

INCLUDES= -I .. \
  $(CHAFF_INCLUDE) $(BOOLEFORCE_INCLUDE) $(MINISAT_INCLUDE) $(MINISAT2_INCLUDE) \
  $(SMVSAT_INCLUDE) $(SQUOLEM2_INC) $(CUDD_INCLUDE) $(BOOLECTOR_INCLUDE) -I ../util 

include ../common

###############################################################################

solvers$(LIBEXT): $(OBJ) $(CHAFF_LIB) $(BOOLEFORCE_LIB) $(MINISAT_LIB) \
        $(MINISAT2_LIB) $(SMVSAT_LIB) $(SQUOLEM2_LIB) $(CUDD_LIB) \
        $(BOOLECTOR_LIB)
	$(LINKLIB)

clean:
	rm -f $(OBJ) solvers$(LIBEXT)

=== src/util/Makefile ===
--- 
+++ 
@@ -8,7 +8,7 @@
       get_module.cpp string_hash.cpp string_container.cpp identifier.cpp \
       rational.cpp options.cpp c_misc.cpp simplify_expr.cpp dstring.cpp \
       find_symbols.cpp rational_tools.cpp ui_message.cpp simplify_utils.cpp \
-      time_stopping.cpp symbol.cpp \
+      time_stopping.cpp symbol.cpp irep_hash_container.cpp \
       type_eq.cpp guard.cpp array_name.cpp gcd.cpp message_stream.cpp \
       substitute.cpp decision_procedure.cpp union_find.cpp pretty_names.cpp \
       xml.cpp xml_irep.cpp std_types.cpp std_code.cpp \
@@ -31,6 +31,10 @@
   CXXFLAGS += -DHAVE_FLOATBV
 endif
 
+# all the others will need irep_ids.h,
+# which we first need to generate
+.NOTPARALLEL:
+
 ###############################################################################
 
 irep_ids.h: irep_ids_convert$(EXEEXT) irep_ids.txt
@@ -42,7 +46,7 @@
 irep_ids.cpp: irep_ids.inc irep_ids.h
 
 irep_ids_convert$(EXEEXT): irep_ids_convert$(OBJEXT)
-	$(CXX) $(LINKFLAGS) -o $@ irep_ids_convert$(OBJEXT)
+	$(LINKBIN) irep_ids_convert$(OBJEXT)
 
 $(OBJ): irep_ids.h
 
@@ -58,4 +62,4 @@
 ieee_float_test$(OBJEXT): irep_ids.h  
 
 ieee_float_test$(EXEEXT): ieee_float_test$(OBJEXT) ieee_float$(OBJEXT) util$(LIBEXT)
-	$(CXX) $(LINKFLAGS) -o $@ util$(LIBEXT) ieee_float_test$(OBJEXT) ../big-int/bigint$(OBJEXT)
+	$(LINKBIN) util$(LIBEXT) ieee_float_test$(OBJEXT) ../big-int/bigint$(OBJEXT)

=== debian/changelog ===
cbmc (4.0-4) unstable; urgency=low

  * Rename patches and update description to make dpkg-source happy
    (closes: #643074)

 -- Michael Tautschnig <mt@debian.org>  Sat, 22 Oct 2011 00:51:01 +0100

cbmc (4.0-3) unstable; urgency=low

  * Make sure $(LIBS) occurs at end of linker command line to fix Ubuntu build
    failures

 -- Michael Tautschnig <mt@debian.org>  Sun, 10 Jul 2011 17:22:04 +0200

cbmc (4.0-2) unstable; urgency=low

  * Added missing freebsd kernel define
  * Enable parallel builds

 -- Michael Tautschnig <mt@debian.org>  Wed, 15 Jun 2011 10:40:38 +0200

cbmc (4.0-1) unstable; urgency=low

  * New upstream release (all patches merged)
  * Requires suitable minisat version
  * Working watch file

 -- Michael Tautschnig <mt@debian.org>  Tue, 14 Jun 2011 19:12:10 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Priority: extra
 Maintainer: Michael Tautschnig <mt@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), minisat, zlib1g-dev, flex, bison
+Build-Depends: debhelper (>= 7.0.50~), minisat (>= 1:2.2.1-2), zlib1g-dev, flex, bison
 Standards-Version: 3.9.2
 Homepage: http://www.cprover.org/cbmc/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh --parallel $@

## cbmc 4.1

=== src/Makefile ===
DIRS = ansi-c big-int cbmc cpp goto-cc goto-instrument goto-programs floatbv \
       goto-symex langapi pointer-analysis solvers util xmllang

all: cbmc.dir goto-cc.dir goto-instrument.dir

###############################################################################

util.dir: big-int.dir

# everything depends on util
$(patsubst %, %.dir, $(filter-out big-int util, $(DIRS))): util.dir

languages: util.dir langapi.dir \
           cpp.dir ansi-c.dir xmllang.dir

goto-instrument.dir: languages goto-programs.dir pointer-analysis.dir goto-symex.dir

cbmc.dir: languages solvers.dir goto-symex.dir \
          pointer-analysis.dir goto-programs.dir

solvers.dir: floatbv.dir

goto-cc.dir: languages pointer-analysis.dir goto-programs.dir

$(patsubst %, %.dir, $(DIRS)):
	## Entering $(basename $@)
	$(MAKE) $(MAKEARGS) -C $(basename $@)

clean: $(patsubst %, %_clean, $(DIRS))

$(patsubst %, %_clean, $(DIRS)):
	if [ -e $(patsubst %_clean, %, $@)/. ] ; then \
		$(MAKE) $(MAKEARGS) -C $(patsubst %_clean, %, $@) clean ; \
	fi

=== src/ansi-c/Makefile ===
SRC = c_typecast.cpp y.tab.cpp lex.yy.cpp ansi_c_parser.cpp \
      expr2c.cpp ansi_c_language.cpp c_sizeof.cpp c_main.cpp \
      c_types.cpp trans_unit.cpp ansi_c_typecheck.cpp \
      c_link.cpp c_preprocess.cpp c_link_type_eq.cpp \
      c_typecheck_base.cpp c_typecheck_initializer.cpp \
      c_typecheck_typecast.cpp c_typecheck_code.cpp \
      c_typecheck_expr.cpp c_typecheck_type.cpp string_constant.cpp \
      c_qualifiers.cpp c_typecheck_argc_argv.cpp ansi_c_parse_tree.cpp \
      preprocessor_line.cpp ansi_c_convert.cpp ansi_c_convert_type.cpp \
      type2name.cpp cprover_library.cpp anonymous_member.cpp \
      printf_formatter.cpp internal_additions.cpp padding.cpp \
      ansi_c_declaration.cpp designator.cpp concatenate_strings.cpp \
      literals/parse_float.cpp literals/unescape_string.cpp \
      literals/convert_float_literal.cpp \
      literals/convert_character_literal.cpp \
      literals/convert_integer_literal.cpp \
      literals/convert_string_literal.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

CLEANFILES = ansi-c$(LIBEXT) \
  y.tab.h y.tab.cpp lex.yy.cpp y.tab.cpp.output y.output \
  library/converter$(EXEEXT) cprover_library.inc

all: ansi-c$(LIBEXT)

###############################################################################

y.tab.cpp: parser.y
	$(YACC) $(YFLAGS) $$flags -pyyansi_c -d parser.y -o y.tab.cpp

y.tab.h: y.tab.cpp
	if [ -e y.tab.hpp ] ; then mv y.tab.hpp y.tab.h ; else \
        mv y.tab.cpp.h y.tab.h ; fi

lex.yy.cpp: scanner.l
	$(LEX) -Pyyansi_c -o$@ scanner.l

# extra dependencies
y.tab$(OBJEXT): y.tab.cpp y.tab.h
lex.yy$(OBJEXT): y.tab.cpp lex.yy.cpp y.tab.h
cprover_library$(OBJEXT): cprover_library.inc

###############################################################################

library/converter$(EXEEXT): library/converter.cpp
	$(LINKBIN)
	
cprover_library.inc: library/converter$(EXEEXT) library/*.c
	cat library/*.c | library/converter > $@

cprover_library.cpp: cprover_library.inc

###############################################################################

ansi-c$(LIBEXT): $(OBJ) 
	$(LINKLIB)

=== src/cbmc/Makefile ===
SRC = main.cpp parseoptions.cpp bmc.cpp dimacs.cpp languages.cpp \
      bv_cbmc.cpp symex_bmc.cpp show_vcc.cpp cbmc_solvers.cpp \
      xml_interface.cpp \
      counterexample_beautification.cpp \
      counterexample_beautification_greedy.cpp \
      counterexample_beautification_pbs.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../big-int/bigint$(OBJEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../xmllang/xmllang$(LIBEXT) \
      ../solvers/solvers$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I .. -I ../util

LIBS =

include ../config.inc
include ../common

CLEANFILES = cbmc$(EXEEXT)

all: cbmc$(EXEEXT)

ifneq ($(wildcard ../bv_refinement/Makefile),)
  OBJ += ../bv_refinement/bv_refinement$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_BV_REFINEMENT
endif

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_CPP
endif

ifneq ($(wildcard ../java/Makefile),)
  OBJ += ../java/java$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_JAVA
endif

ifneq ($(wildcard ../specc/Makefile),)
  OBJ += ../specc/specc$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_SPECC
endif

ifneq ($(wildcard ../php/Makefile),)
  OBJ += ../php/php$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

cbmc$(EXEEXT): $(OBJ)
	$(LINKBIN)

=== src/cpp/Makefile ===
--- 
+++ 
@@ -16,20 +16,20 @@
       cpp_final.cpp cpp_typecheck_conversions.cpp\
       cpp_typecheck_declaration.cpp cpp_declarator_converter.cpp \
       cpp_declaration.cpp cpp_namespace_spec.cpp \
-      cpp_typecheck_using.cpp \
+      cpp_typecheck_using.cpp cpp_exception_id.cpp \
       cpp_typecheck_enum_type.cpp cpp_typecheck_bases.cpp \
       cpp_typecheck_constructor.cpp cpp_typecheck_virtual_table.cpp
-
-OBJ = $(SRC:.cpp=$(OBJEXT))
 
 INCLUDES= -I .. -I ../util
 
 include ../config.inc
 include ../common
 
+CLEANFILES = cpp$(LIBEXT) lex.yy.cpp y.tab.cpp.output
+
 all: cpp$(LIBEXT)
 
-GCCFLAGS += -D CPP_SYSTEMC_EXTENSION
+CP_CXXFLAGS += -D CPP_SYSTEMC_EXTENSION
 
 ###############################################################################
 
@@ -41,8 +41,3 @@
 
 lex.yy$(OBJEXT): lex.yy.cpp
 
-clean:
-	rm -f $(OBJ) cpp$(LIBEXT) lex.yy.cpp y.tab.cpp.output
-
-dep: lex.yy.cpp
-

=== src/floatbv/Makefile ===
SRC = float_utils.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

LIBS = ../solvers/solvers$(LIBEXT) \
			 ../util/util$(LIBEXT) \
			 ../big-int/bigint$(OBJEXT)

CLEANFILES = floatbv$(LIBEXT) float_utils_test$(EXEEXT)

all: floatbv$(LIBEXT)

###############################################################################

floatbv$(LIBEXT): $(OBJ)
	$(LINKLIB)

float_utils_test$(EXEEXT): float_utils_test$(OBJEXT)
	$(LINKBIN)

=== src/goto-cc/Makefile ===
--- 
+++ 
@@ -12,8 +12,7 @@
       xml_binaries/xml_goto_program_hashing.cpp \
       xml_binaries/read_goto_object.cpp
 
-OBJ = $(SRC:.cpp=$(OBJEXT)) \
-      ../big-int/bigint$(OBJEXT) \
+OBJ += ../big-int/bigint$(OBJEXT) \
       ../goto-programs/goto-programs$(LIBEXT) \
       ../pointer-analysis/pointer-analysis$(LIBEXT) \
       ../util/util$(LIBEXT) \
@@ -25,20 +24,20 @@
 
 LIBS =
 
+CLEANFILES = goto-cc$(EXEEXT)
+
 include ../config.inc
 include ../common
 
 all: goto-cc$(EXEEXT)
 
-ifdef MODULE_CPP
+ifneq ($(wildcard ../cpp/Makefile),)
   OBJ += ../cpp/cpp$(LIBEXT)
-  CXXFLAGS += -D HAVE_CPP
+  CP_CXXFLAGS += -D HAVE_CPP
 endif
 
 ###############################################################################
 
 goto-cc$(EXEEXT): $(OBJ)
-	$(LINKBIN) $(OBJ)
+	$(LINKBIN)
 
-clean:
-	rm -f $(SRC:.cpp=$(OBJEXT)) $(SRC:.cpp=.d) goto-cc$(EXEEXT)

=== src/goto-instrument/Makefile ===
SRC = main.cpp parseoptions.cpp document_claims.cpp languages.cpp \
      uninitialized.cpp uninitialized_domain.cpp full_slicer.cpp \
      object_id.cpp show_locations.cpp points_to.cpp \
      alignment_checks.cpp race_check.cpp rw_set.cpp \
      weak_memory.cpp nondet_volatile.cpp interrupt.cpp \
      mmio.cpp stack_depth.cpp nondet_static.cpp

OBJ += ../ansi-c/ansi-c$(LIBEXT) \
      ../big-int/bigint$(OBJEXT) \
      ../goto-programs/goto-programs$(LIBEXT) \
      ../goto-symex/goto-symex$(LIBEXT) \
      ../pointer-analysis/pointer-analysis$(LIBEXT) \
      ../langapi/langapi$(LIBEXT) \
      ../util/util$(LIBEXT)

INCLUDES= -I .. -I ../util

LIBS =

CLEANFILES = goto-instrument$(EXEEXT)

include ../config.inc
include ../common

all: goto-instrument$(EXEEXT)

ifneq ($(wildcard ../cpp/Makefile),)
  OBJ += ../cpp/cpp$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_CPP
endif

ifneq ($(wildcard ../java/Makefile),)
  OBJ += ../java/java$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_JAVA
endif

ifneq ($(wildcard ../specc/Makefile),)
  OBJ += ../specc/specc$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_SPECC
endif

ifneq ($(wildcard ../php/Makefile),)
  OBJ += ../php/php$(LIBEXT)
  CP_CXXFLAGS += -DHAVE_PHP
endif

###############################################################################

goto-instrument$(EXEEXT): $(OBJ)
	$(LINKBIN)

=== src/goto-programs/Makefile ===
SRC = goto_convert.cpp goto_function.cpp goto_main.cpp goto_sideeffects.cpp \
      goto_program.cpp basic_blocks.cpp goto_check.cpp \
      remove_function_pointers.cpp goto_functions.cpp goto_inline.cpp \
      remove_skip.cpp goto_convert_functions.cpp string_instrumentation.cpp \
      builtin_functions.cpp show_claims.cpp destructor.cpp set_claims.cpp \
      reachability_slicer.cpp invariant_set.cpp invariant_propagation.cpp \
      read_goto_binary.cpp \
      invariant_set_domain.cpp static_analysis.cpp string_abstraction.cpp \
      goto_program_serialization.cpp goto_function_serialization.cpp \
      read_bin_goto_object.cpp goto_program_irep.cpp interpreter.cpp \
      interpreter_evaluate.cpp flow_insensitive_analysis.cpp \
      format_strings.cpp loop_numbers.cpp pointer_arithmetic.cpp \
      goto_program_template.cpp write_goto_binary.cpp remove_unreachable.cpp \
      remove_unused_functions.cpp dynamic_memory.cpp dump_c.cpp \
      wp.cpp goto_rw.cpp goto_clean_expr.cpp safety_checker.cpp \
      compute_called_functions.cpp link_to_library.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

LIBS = ../ansi-c/ansi-c$(LIBEXT)  ../util/util$(LIBEXT) \
	../big-int/bigint$(OBJEXT) goto-programs$(LIBEXT) \
	../pointer-analysis/pointer-analysis$(LIBEXT) \
	../langapi/langapi$(LIBEXT)

CLEANFILES = goto-programs$(LIBEXT) test_wp$(EXEEXT)

all: goto-programs$(LIBEXT)

###############################################################################

goto-programs$(LIBEXT): $(OBJ)
	$(LINKLIB)

test_wp$(EXEEXT): test_wp$(OBJEXT) goto-programs$(LIBEXT)
	$(LINKBIN)

=== src/goto-symex/Makefile ===
--- 
+++ 
@@ -4,14 +4,15 @@
       symex_goto.cpp builtin_functions.cpp slice.cpp symex_other.cpp \
       slice_by_trace.cpp xml_goto_trace.cpp symex_decl.cpp \
       precondition.cpp postcondition.cpp symex_clean_expr.cpp \
-      symex_dereference_state.cpp vcd_goto_trace.cpp auto_objects.cpp
-
-OBJ = $(SRC:.cpp=$(OBJEXT))
+      symex_dereference_state.cpp vcd_goto_trace.cpp auto_objects.cpp \
+      symex_catch.cpp
 
 INCLUDES= -I .. -I ../util
 
 include ../config.inc
 include ../common
+
+CLEANFILES = goto-symex$(LIBEXT)
 
 all: goto-symex$(LIBEXT)
 
@@ -20,6 +21,3 @@
 goto-symex$(LIBEXT): $(OBJ)
 	$(LINKLIB)
 
-clean:
-	rm -f $(OBJ) goto-symex$(LIBEXT)
-

=== src/langapi/Makefile ===
SRC = mode.cpp language_ui.cpp languages.cpp language_util.cpp

INCLUDES= -I .. -I ../util

include ../config.inc
include ../common

CLEANFILES = langapi$(LIBEXT)

all: langapi$(LIBEXT)

###############################################################################

langapi$(LIBEXT): $(OBJ)
	$(LINKLIB)

=== src/pointer-analysis/Makefile ===
--- 
+++ 
@@ -6,12 +6,12 @@
       value_set_analysis_fivrns.cpp value_set_fivrns.cpp \
       value_set_domain_fivrns.cpp
 
-OBJ = $(SRC:.cpp=$(OBJEXT))
-
 INCLUDES= -I .. -I ../util
 
 include ../config.inc
 include ../common
+
+CLEANFILES = pointer-analysis$(LIBEXT)
 
 all: pointer-analysis$(LIBEXT)
 
@@ -20,6 +20,3 @@
 pointer-analysis$(LIBEXT): $(OBJ)
 	$(LINKLIB)
 
-clean:
-	rm -f $(OBJ) pointer-analysis$(LIBEXT)
-

=== src/solvers/Makefile ===
--- 
+++ 
@@ -1,53 +1,31 @@
 include ../config.inc
-
-all: solvers$(LIBEXT)
+include ../common
 
 ifneq ($(CHAFF),)
   CHAFF_SRC=sat/satcheck_zchaff.cpp sat/satcheck_zcore.cpp
   CHAFF_INCLUDE=-I $(CHAFF)
-  CHAFF_LIB=$(CHAFF)/libsat.a
-endif
-
-ifneq ($(BOOLEFORCE),)
-  BOOLEFORCE_SRC=sat/satcheck_booleforce.cpp
-  BOOLEFORCE_INCLUDE=-I $(BOOLEFORCE)
-  BOOLEFORCE_LIB=$(BOOLEFORCE)/libbooleforce.a
-endif
-
-ifneq ($(Z3),)
-  Z3_SRC=z3/z3_capi.cpp z3/z3_conv.cpp z3/z3_prop.cpp z3/z3_dec.cpp
-  Z3_INCLUDE=-I $(Z3)
-  Z3_LIB=
-  CXXFLAGS += -DHAVE_Z3
-endif
-
-ifneq ($(BOOLECTOR),)
-  BOOLECTOR_SRC=boolector/boolector_get.cpp \
-                boolector/boolector_prop.cpp boolector/boolector_dec.cpp
-  BOOLECTOR_INCLUDE=-I $(BOOLECTOR)
-  BOOLECTOR_LIB=$(BOOLECTOR)/lib/libboolector.a
-  CXXFLAGS += -DHAVE_BOOLECTOR
+  CHAFF_LIB=$(CHAFF)/libsat$(LIBEXT)
 endif
 
 ifneq ($(MINISAT),)
-  MINISAT_SRC=sat/satcheck_minisat.cpp 
+  MINISAT_SRC=sat/satcheck_minisat.cpp
   MINISAT_INCLUDE=-I $(MINISAT)
   MINISAT_LIB=$(MINISAT)/Solver$(OBJEXT) $(MINISAT)/Proof$(OBJEXT) $(MINISAT)/File$(OBJEXT)
-  CXXFLAGS += -DHAVE_MINISAT
+  CP_CXXFLAGS += -DHAVE_MINISAT
 endif
 
 ifneq ($(MINISAT2),)
   MINISAT2_SRC=sat/satcheck_minisat2.cpp
   MINISAT2_INCLUDE=-I $(MINISAT2)
   MINISAT2_LIB=$(MINISAT2)/simp/SimpSolver$(OBJEXT) $(MINISAT2)/core/Solver$(OBJEXT)
-  CXXFLAGS += -DHAVE_MINISAT2 -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS
-  GCCFLAGS := $(filter-out -pedantic, $(GCCFLAGS))
+  CP_CXXFLAGS += -DHAVE_MINISAT2 -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS
+  CXXFLAGS := $(filter-out -pedantic, $(CXXFLAGS))
 endif
 
 ifneq ($(SMVSAT),)
   SMVSAT_SRC=sat/satcheck_smvsat.cpp
   SMVSAT_INCLUDE=-I $(SMVSAT)/include
-  SMVSAT_LIB=$(SMVSAT)/lib/libsmvsat.a
+  SMVSAT_LIB=$(SMVSAT)/lib/libsmvsat$(LIBEXT)
 endif
 
 ifneq ($(SQUOLEM2),)
@@ -65,8 +43,7 @@
 endif
 
 SRC = $(CHAFF_SRC) $(BOOLEFORCE_SRC) $(MINISAT_SRC) $(MINISAT2_SRC) \
-      $(SMVSAT_SRC) $(SQUOLEM2_SRC) $(CUDD_SRC) $(BOOLECTOR_SRC) \
-      $(Z3_SRC) \
+      $(SMVSAT_SRC) $(SQUOLEM2_SRC) $(CUDD_SRC) \
       sat/cnf.cpp sat/dimacs_cnf.cpp sat/cnf_clause_list.cpp \
       sat/pbs_dimacs_cnf.cpp sat/read_dimacs_cnf.cpp \
       sat/resolution_proof.cpp sat/satcheck.cpp \
@@ -102,35 +79,36 @@
       flattening/boolbv_quantifier.cpp flattening/boolbv_struct.cpp \
       flattening/boolbv_byte_update.cpp flattening/boolbv_array_of.cpp \
       flattening/boolbv_map.cpp flattening/boolbv_type.cpp \
-      flattening/boolbv_union.cpp
+      flattening/boolbv_union.cpp flattening/flatten_byte_operators.cpp
 
-OBJ = $(SRC:.cpp=$(OBJEXT))
+INCLUDES= -I .. \
+  $(CHAFF_INCLUDE) $(BOOLEFORCE_INCLUDE) $(MINISAT_INCLUDE) $(MINISAT2_INCLUDE) \
+  $(SMVSAT_INCLUDE) $(SQUOLEM2_INC) $(CUDD_INCLUDE) -I ../util
+
+CLEANFILES = solvers$(LIBEXT)
+
+all: solvers$(LIBEXT)
 
 ifneq ($(SQUOLEM2),)
-  CXXFLAGS += -DHAVE_QBF_CORE
+  CP_CXXFLAGS += -DHAVE_QBF_CORE
 else
 ifneq ($(CUDD),)
-  CXXFLAGS += -DHAVE_QBF_CORE
+  CP_CXXFLAGS += -DHAVE_QBF_CORE
 endif
 endif
 
-ifdef MODULE_FLOATBV
-  CXXFLAGS += -DHAVE_FLOATBV
+ifneq ($(wildcard ../floatbv/Makefile),)
+  CP_CXXFLAGS += -DHAVE_FLOATBV
   OBJ += ../floatbv/floatbv$(LIBEXT)
 endif
 
-INCLUDES= -I .. \
-  $(CHAFF_INCLUDE) $(BOOLEFORCE_INCLUDE) $(MINISAT_INCLUDE) $(MINISAT2_INCLUDE) \
-  $(SMVSAT_INCLUDE) $(SQUOLEM2_INC) $(CUDD_INCLUDE) $(BOOLECTOR_INCLUDE) -I ../util 
+# extra dependencies
 
-include ../common
+-include $(SRC:.cpp=.d)
 
 ###############################################################################
 
 solvers$(LIBEXT): $(OBJ) $(CHAFF_LIB) $(BOOLEFORCE_LIB) $(MINISAT_LIB) \
-        $(MINISAT2_LIB) $(SMVSAT_LIB) $(SQUOLEM2_LIB) $(CUDD_LIB) \
-        $(BOOLECTOR_LIB)
+        $(MINISAT2_LIB) $(SMVSAT_LIB) $(SQUOLEM2_LIB) $(CUDD_LIB)
 	$(LINKLIB)
 
-clean:
-	rm -f $(OBJ) solvers$(LIBEXT)

=== debian/changelog ===
cbmc (4.1-1) unstable; urgency=low

  * New upstream release (all code patches merged, only build system adaptions
    remain)
  * dh-compat bumped to 9

 -- Michael Tautschnig <mt@debian.org>  Wed, 18 Jan 2012 18:37:41 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Priority: extra
 Maintainer: Michael Tautschnig <mt@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), minisat (>= 1:2.2.1-2), zlib1g-dev, flex, bison
+Build-Depends: debhelper (>= 9), minisat (>= 1:2.2.1-2), zlib1g-dev, flex, bison
 Standards-Version: 3.9.2
 Homepage: http://www.cprover.org/cbmc/

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,8 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
+CXXFLAGS = -Wall -O2 -g -Werror -Wno-long-long -Wno-sign-compare -Wno-parentheses -Wno-strict-aliasing -pedantic
+
 %:
-	dh --parallel $@ 
+	dh $@ --parallel
